// File: android/app/src/main/kotlin/com/example/dialer/MyConnectionService.kt
package com.example.dialer

import android.content.Intent
import android.net.Uri
import android.telecom.Connection
import android.telecom.ConnectionRequest
import android.telecom.ConnectionService
import android.telecom.PhoneAccountHandle
import android.util.Log

class MyConnectionService : ConnectionService() {

    override fun onCreateIncomingConnection(
        connectionManagerPhoneAccount: PhoneAccountHandle,
        request: ConnectionRequest
    ): Connection? {
        Log.d("MyConnectionService", "onCreateIncomingConnection")
        val myConnection = MyConnection()

        // Try to extract the incoming phone number from the request.
        val phoneUri: Uri? = request.address
        val phoneNumber = phoneUri?.schemeSpecificPart ?: "Unknown"

        // Broadcast an intent so MainActivity can notify Flutter.
        val intent = Intent("com.example.dialer.INCOMING_CALL")
        intent.putExtra("phoneNumber", phoneNumber)
        applicationContext.sendBroadcast(intent)

        // Mark the connection as ringing.
        myConnection.setRinging()
        return myConnection
    }

    override fun onCreateOutgoingConnection(
        connectionManagerPhoneAccount: PhoneAccountHandle,
        request: ConnectionRequest
    ): Connection? {
        Log.d("MyConnectionService", "onCreateOutgoingConnection")
        val myConnection = MyConnection()
        myConnection.setDialing()
        return myConnection
    }
}
